// rb.js: main javascript file for researchbuddy

//global variables

var prefs;
var topics = new Array();
var selectedTopic = -1;
var topicsFile = getProfilePath("topics.dat");
var prefsFile = getProfilePath("prefs.cfg");
var topicsFileExists = false;
var prefsFileExists = false;
var prefSeparator = "|";
var slash;
var domDoc;
var selectedText;
var timeVisited = new Date();
//var domDocTitle;
//var domDocURL;

//structure for storing preferences
function Pref(saveImages, saveHTML, rootDir, format) 
{
   this.saveImages = saveImages;
   this.saveHTML = saveHTML;
   this.rootDir = rootDir;
   this.format = format ;
}

function init()
{
	//alert("we're in init.");
	//alert("Current time and date: " + date + "  " + location.href);
	try 
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) 
	{
		alert("Permission to save file was denied.");
	}

	setView(); 
	selectedTopic = document.getElementById('topictree').currentIndex;	
	
	//if the topics file doesn't exist, create a new empty one
	if(read(topicsFile) == "")
	{
		save(topicsFile, "");
	}
	loadPrefsFromFile();

	slash = setFileSeparator();
	
	domDoc = window.arguments[1];
	
	selectedText = window.arguments[0];
}

//*************************************************************** model 

// prefs object constructor


function createNewTopic()
{
	var obj = new Object();
	obj.newTopic = "";
	var newWin = window.openDialog("dialog.xul",
      "_blank", "chrome,modal",
      obj, topics);
      
    //alert("back from dialog");
	var newTopic = ""+obj.newTopic +"";
	
//	currentTopic = topics.length-1;
	
	if(obj.newTopic) //then we got a successful new name and we should add it
	{
		//add to array
		topics[topics.length] = newTopic;
		saveTopics();
		setView();
		var newTopicFile = removeLastSlash(prefs.rootDir) + slash + topics[topics.length-1] + slash + "bibliography.xml";
		//alert("Creating file: " + newTopicFile);
		save(newTopicFile, "<?xml version='1.0' encoding='ISO-8859-1' ?> <bibliography />");
	}
}

function savePrefs()
{
	prefs = new Pref(getCheckboxValue('saveIMG'), getCheckboxValue('saveHTML'),
			document.getElementById('rootDirTextBox').value, document.getElementById('formatTextBox').value);
	//save to file
	var outputStr = prefs.saveImages + prefSeparator + prefs.saveHTML + prefSeparator + prefs.rootDir + prefSeparator + prefs.format + prefSeparator;
	save(prefsFile, outputStr);
}

function saveTopics()
{
	//alert("Number of Topics " + topics.length)
	var outputStr = "";
	if(topics.length > 0)
	{
		for (i = 0; i < topics.length-1; i++)
		{
			outputStr += topics[i] + prefSeparator;   
		}
		//alert("outputStr = " + outputStr + " numTopics " + topics.length);
		outputStr += topics[topics.length-1];
	}
	save(topicsFile, outputStr);
}

function getCheckboxValue(checkboxID)
{
	if(document.getElementById(checkboxID).checked)
	{
		return 1;
	}
	else
	{
		return "";
	}
}

function loadPrefsFromFile()
{
	if(read(prefsFile) == "")
	{
		//set default prefs if prefs file does not exist
		var outputStr = prefSeparator + "1" + prefSeparator + getProfilePath("") + prefSeparator + "<b>%T</b> %L %M-%D-%Y @ %H:%N:%S %A<br> %Q" + prefSeparator; 
		save(prefsFile, outputStr);
	}	
	var prefArray = read(prefsFile).split(prefSeparator);
	prefs = new Pref(prefArray[0], prefArray[1], prefArray[2], prefArray[3]); 
}

function loadPrefs()
{
	loadPrefsFromFile();
	
	document.getElementById('saveIMG').checked = prefs.saveImages;
	document.getElementById('saveHTML').checked = prefs.saveHTML;
	document.getElementById('rootDirTextBox').value = prefs.rootDir;
	document.getElementById('formatTextBox').value = prefs.format;

	if(document.getElementById('saveHTML').checked == true)
	{
		document.getElementById('saveIMG').disabled=false;	
	}
	else
	{
		document.getElementById('saveIMG').disabled=true;
	}
}

function editPrefs()
{
	window.openDialog("chrome://researchbuddy/content/rbprefsGUI.xul", "Edit Prefrences", "close,modal,chrome");
	//alert("got back from prefs");
	loadPrefsFromFile();
}

//*************************************************************** view functions

//creates a custom tree view based on an array
function createView(arrayName)
{
	return treeView =
	{
	    rowCount : arrayName.length,
    
    	getCellText : function(row,column)
		{
	    	if(arrayName.length == 0) return;
    		if(column == "topiccol") return topics[row];          
	    },
    
	    setTree: function(treebox){ this.treebox=treebox; },
	    isContainer: function(row){ return false; },
	    isSeparator: function(row){ return false; },
	    isSorted: function(row){ return false; },
	    getLevel: function(row){ return 0; },
	    getImageSrc: function(row,col){ return null; },
	    getRowProperties: function(row,props){},
	    getCellProperties: function(row,col,props){},
	    getColumnProperties: function(colid,col,props){}
	};
}

//update the tree view
function setView()
{
	//alert("numTopics " + topics.length);
	if(read(topicsFile) == "" )
	{
		topics = read(topicsFile).split(prefSeparator, 0);
	}
	else
	{
		topics = read(topicsFile).split(prefSeparator);
	}
	//alert("numTopics after read " + topics.length);
	document.getElementById('topictree').view = createView(topics); 
	//disable some buttons
	setButtons();
}

//opens the external xul file for viewing a topic's bibliography
function viewTopic()
{
	if(selectedTopic < 0)
	{
		alert("You must select something");
	}
	else
	{
		try 
		{
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
			callViewTopic(removeLastSlash(prefs.rootDir) + slash + topics[selectedTopic] + slash, prefs.format, topics[selectedTopic]);
		} 
		catch (e) 
		{
			alert("Permission to save file was denied." + e);
		}
	}
}

function setButtons()
{
	selectedTopic = document.getElementById('topictree').currentIndex;

	//alert("selectedTopic = " + selectedTopic);

	if(selectedTopic < 0)
	{
		document.getElementById('renameTopic').disabled = true;
		document.getElementById('deleteTopic').disabled = true;	
		document.getElementById('viewTopic').disabled = true;	
		document.getElementById('addToSelected').disabled = true;
	}
	else
	{
		document.getElementById('renameTopic').disabled = false;
		document.getElementById('deleteTopic').disabled = false;	
		document.getElementById('viewTopic').disabled = false;	
		document.getElementById('addToSelected').disabled = false;
	}
}

function setCheckboxes()
{
	if(document.getElementById('saveHTML').checked)
	{
		document.getElementById('saveIMG').disabled = true;
		document.getElementById('saveIMG').checked = false;
	}
	else
	{
		document.getElementById('saveIMG').disabled = false;
	}
}

//*************************************************************** control

function selectTopic()
{
	selectedTopic = document.getElementById('topictree').currentIndex;
	setButtons();
	//alert("selectedTopic " + selectedTopic + "  = " + topics[selectedTopic]);
}

function getProfilePath(savefile)
{
	// Jacked from http://www.captain.at/programming/xul/ - Modified Slightly
	try 
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} 
	catch (e) 
	{
		alert("Permission to save file was denied.");
	}
	// get the path to the user's home (profile) directory
	const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
	try 
	{
		path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
	} 
	catch (e) 
	{
		alert("error");
	}
	// determine the file-separator
	if (path.search(/\\/) != -1) 
	{
		path = path + "\\";
	} 
	else 
	{
		path = path + "/";
	}
	savefile = path+savefile;
	return savefile;
}

function read(filepath)
{
	// Jacked from http://www.captain.at/programming/xul/ - Modified Slightly
	try 
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} 
	catch (e) 
	{
		alert("Permission to read file was denied.");
	}
	
	var file = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath( filepath );
	
	if ( file.exists() == false ) 
	{
//		alert("File does not exist");
		return "";
	}
	
	var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
		.createInstance( Components.interfaces.nsIFileInputStream );
	is.init( file,0x01, 00004, null);
	
	var sis = Components.classes["@mozilla.org/scriptableinputstream;1"]
		.createInstance( Components.interfaces.nsIScriptableInputStream );
	sis.init( is );
	var output = sis.read( sis.available() );
	
	return output;
}

function renameFile(sourcefile,destfile)
{
	//alert("sourcefile = "+sourcefile+", destfile = "+destfile);
	var aFile = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	if (!aFile) 
	{
		alert("in renameFile, aFile = null");
		return false;
	}

	// next, assign URLs to the file components
	aFile.initWithPath(sourcefile);

	// finally, copy the file, without renaming it
	aFile.moveTo(null,destfile);
}

function save(filepath, outputString) 
{
	//alert("saving file "+filepath);
	// Jacked from http://www.captain.at/programming/xul/ - Modified Slightly
	try 
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} 
	catch (e) 
	{
		alert("Permission to save file was denied.");
	}
	var file = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
//	alert("attempting to save to filepath = "+filepath);
	file.initWithPath( filepath );
	if ( file.exists() == false ) 
	{
		//alert( "Creating file... " );
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
		topicsFileExists = false;
	}
	else
	{
		topicsFileExists = true;
	}
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance( Components.interfaces.nsIFileOutputStream );
	/* Open flags 
	#define PR_RDONLY       0x01
	#define PR_WRONLY       0x02
	#define PR_RDWR         0x04
	#define PR_CREATE_FILE  0x08
	#define PR_APPEND      0x10
	#define PR_TRUNCATE     0x20
	#define PR_SYNC         0x40
	#define PR_EXCL         0x80
	*/
	/*
	** File modes ....
	**
	** CAVEAT: 'mode' is currently only applicable on UNIX platforms.
	** The 'mode' argument may be ignored by PR_Open on other platforms.
	**
	**   00400   Read by owner.
	**   00200   Write by owner.
	**   00100   Execute (search if a directory) by owner.
	**   00040   Read by group.
	**   00020   Write by group.
	**   00010   Execute by group.
	**   00004   Read by others.
	**   00002   Write by others
	**   00001   Execute by others.
	**
	*/
	outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
	var result = outputStream.write( outputString, outputString.length );
	outputStream.close();
}

function getMeridiem()
{
	if(timeVisited.getHours() > 12)
	{
		return "pm";
	}
	else
	{
		return "am";
	}
}

function getProperHour()
{
	if(timeVisited.getHours() > 12)
	{
		return (timeVisited.getHours() - 12);
	}
	else
	{
		return timeVisited.getHours();
	}
}

function addToSelected()
{
	//writeXml(text, rootDir, topic, link, title, month, day, year, hour, min, sec, ampm);
	var serializer, docStr, rootDir;
	if(selectedTopic < 0)
	{
		alert("You must select something");
	}
	else
	{
		//alert("savehtml = "+prefs.saveHTML+", saveimg = "+prefs.saveImages);
		if(prefs.saveHTML == 1)
		{
			rootDir = removeLastSlash(prefs.rootDir) + slash + topics[selectedTopic];
			relDir = removeLastSlash(domDoc.title);
			var count = 0;
			var tmpRelDir = relDir;
			var found = 1;

			//this loop generates a unique dirname to save the content into
			//this was necessary since many pages may have the same title
			//and we didn't want old ones to be overwritten
			while(found)
			{
				var file = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
				file.initWithPath( rootDir + slash + tmpRelDir );
				//alert("checking filepath = "+rootDir+slash+tmpRelDir)
				if (file.exists() == false) 
				{
					//alert("ok to write");
					found = 0;
				}
			    if (count > 100)
			    {
			        alert("You have saved something 100 times with the same page title.  We do not support any more.  Try adding to a new topic");
			        return;
			    }
				if(found == 1)
				{
					count++;
					tmpRelDir = relDir+count;
				}
			}

			
			tmpRelDir = legalizeFilename(tmpRelDir);
			destpath = rootDir + slash + tmpRelDir;

			//if we are saving images, use the built-in saveDocument function
			//we couldn't get the "body-only" flag working, so a non-image one
			//just serializes the document and writes it.
			if(prefs.saveImages)
			{
				//alert("saving with images");
				var file = Components.classes["@mozilla.org/file/local;1"].
			        createInstance(Components.interfaces.nsILocalFile);
				var result = file.initWithPath(destpath + slash + "index.html");
				//alert("got file = "+file);
				
				var dir = Components.classes["@mozilla.org/file/local;1"].
					createInstance(Components.interfaces.nsILocalFile);
				result = dir.initWithPath(destpath + slash);
				//alert("got file = "+dir);
				
				var saveFile = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
					createInstance(Components.interfaces.nsIWebBrowserPersist);
				result = saveFile.saveDocument(domDoc, file, dir, null, null, null);
				//alert("saved file = "+saveFile);
			}
			else //don't save images: just serialize the document and write
			{
				//alert("using no-images: serializing and writing");
				serializer = new XMLSerializer();
				docStr = serializer.serializeToString(domDoc);
				//alert("serialized html doc: "+docStr);
				save(destpath+slash+"index.html", docStr);
				//alert("done with no-images");
			}
			//alert("done saving.");
		}
		writeXml(selectedText, prefs.rootDir, topics[selectedTopic], domDoc.location.href, domDoc.title, timeVisited.getMonth()+1, timeVisited.getDate(), timeVisited.getFullYear(), getProperHour(), getFormattedMinutes(), getFormattedSeconds(), getMeridiem())
	}
	window.close();
}

function getFormattedMinutes()
{
	if(timeVisited.getMinutes() < 10)
	{
		var strzero = "0";
		return(strzero.concat(timeVisited.getMinutes()));
	}
	else
	{
		return timeVisited.getMinutes();
	}
}

function getFormattedSeconds()
{
	if (timeVisited.getSeconds() < 10) 
	{
		var strzero = "0";
		return(strzero.concat(timeVisited.getSeconds()));
	} else 
	{
		return timeVisited.getSeconds();
	}
}

//some annoying platforms (mac? what?) add a slash to the dirname by default.
function removeLastSlash(str) 
{
	return str.replace(/\/$/,'');
}

function legalizeFilename(str) 
{
	var newstr = str.replace(/\?/g,'');
	return newstr.replace(/:/g,'');
}

function renameTopic()
{
	if(selectedTopic < 0)
	{
		alert("You must select something to rename it.");
	}
	else
	{
		var obj = new Object();
		obj.newTopic = topics[selectedTopic];
		var newWin = window.openDialog("dialog.xul",
	      "_blank", "chrome,modal",
	      obj, topics, selectedTopic);
	      
		if(obj.newTopic)
		{
			topicName = obj.newTopic;
	    	//alert("back from diag: valid new name:" + topicName);
			try 
			{
				netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
			} catch (e) 
			{
				alert("Permission to save file was denied.");
			}
			srcFile = removeLastSlash(prefs.rootDir) + slash + topics[selectedTopic];
			destFile = removeLastSlash(prefs.rootDir) + slash + topicName;
			//alert("about to rename from <"+srcFile+"> to <"+destFile+">");

			//move the file to the new topice name
			renameFile(srcFile, topicName);
			//alert("after renaming");
			topics.splice(selectedTopic, 1, topicName);
			saveTopics();
			setView();
		}
	}
}

function deleteTopic()
{
	if(selectedTopic < 0)
	{
		alert("You must select something");
	}
	else
	{
		try 
		{
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} 
		catch (e) 
		{
			alert("Permission to save file was denied.");
		}

		var file = Components.classes["@mozilla.org/file/local;1"].
			createInstance(Components.interfaces.nsILocalFile);
		var fileToBeRemoved = removeLastSlash(prefs.rootDir) + slash + topics[selectedTopic];
//		alert(fileToBeRemoved + "selected Topic = " + selectedTopic);
		try
		{
			file.initWithPath(fileToBeRemoved);
			file.remove(true);
		}
		catch (e)
		{
			alert("Failed to remove directory: did you change your root directory? Removing from the list anyway.");
		}
		topics.splice(selectedTopic, 1);
		//alert(topics.length + " topics left");
		saveTopics();
		setView();
	}
}

//function to get a cross-platform-compliant file separator
//this is a hack, and we love hacks, so we use it :)
function setFileSeparator()
{
	var rootDir = prefs.rootDir;
	var fileSeparator;

	var file = Components.classes["@mozilla.org/file/local;1"].
		createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(rootDir);
	file.append("temp.tmp");
	if (file.path.search(/\\/) != -1) 
	{
		fileSeparator = "\\";
	} 
	else 
	{
		fileSeparator = "/";
	}
	return fileSeparator;
}

function writeXml(text, rootDir, topic, link, title, month, day, year, hour, min, sec, ampm)
{
	var thisHtml, root, c, d, biblio, cite, xmlContent, xmlDoc, parser;
	var thepath = rootDir+slash+topic+slash+"bibliography.xml";
	try
	{
		//spent SOOOOOOOO long trying to get xmlDoc.load() to work
		//and in the end, we just read the file raw, and parse it
		xmlContent = read(thepath);
		parser = new DOMParser();
		xmlDoc = parser.parseFromString(xmlContent, "text/xml");
	}
	catch(err)
	{
		alert(err);
		return
	}
	serializer = new XMLSerializer();
	docStr = serializer.serializeToString(xmlDoc);
	//alert("docStr = " + docStr + ", path = <"+thepath+">");
	biblio = xmlDoc.getElementsByTagName("bibliography").item(0);
	//alert("biblio = "+biblio+", len = "+xmlDoc.getElementsByTagName("bibliography").length);
	var cite = xmlDoc.createElement("citation");

	var weblink = xmlDoc.createElement("weblink");
	var textnode = xmlDoc.createTextNode(link);
	weblink.appendChild(textnode);
	cite.appendChild(weblink);

	var textChild = xmlDoc.createElement("text");
	var textnode2 = xmlDoc.createTextNode(text);
	textChild.appendChild(textnode2);
	cite.appendChild(textChild);

	var titleChild = xmlDoc.createElement("title");
	var textnode3 = xmlDoc.createTextNode(title);
	titleChild.appendChild(textnode3);
	cite.appendChild(titleChild);

	var dateChild = xmlDoc.createElement("date");
	dateChild.setAttribute("month", month);
	dateChild.setAttribute("day", day);
	dateChild.setAttribute("year", year);
	dateChild.setAttribute("hour", hour);
	dateChild.setAttribute("min", min);
	dateChild.setAttribute("sec", sec);
	dateChild.setAttribute("ampm", ampm);
	cite.appendChild(dateChild);

	biblio.appendChild(cite);

	//serialize our altered domdoc, and write it back out to the same file
	var serializer = new XMLSerializer();
	var docStr = serializer.serializeToString(xmlDoc);

	//alert("new docstr = "+docStr);
	//alert("saving to path = "+thepath);
	save(thepath, docStr);
	//alert("done updating the xml");
}

//file-picker stuff.  glorious
function pickDirectory()
{
	try 
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} 
	catch (e) 
	{
		alert("Permission to save file was denied.");
	}
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a File", nsIFilePicker.modeGetFolder);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK)
	{
  		var thefile = fp.file;
  		document.getElementById('rootDirTextBox').value = fp.file.path;
	}
}

function trimString (str) 
{
	str = this != window? this : str;
	return str.replace(/^\s+/g, '').replace(/\s+$/g, '');
}

function callViewTopic(inFname, format, topicName)
{
	var fname = inFname + "bibliography.xml";

	//these three lines are from when this was its own xul file, not just a function
//	var inFname = window.arguments[0];
//	var format = window.arguments[1];
//	var topicName = window.arguments[2];
	//alert("fname = "+fname+", topicName="+topicName);
	var link, text, title, fulldate, month, day, year, hour, min, sec, ampm;
	var regx, tempStr, gBrow, newTab;
	var thisHtml, root, c, d, citations;
	var xmlDoc, xmlContent, parser;
	try
	{
		xmlContent = read(fname);
		//alert("xml file content = "+xmlContent);
		parser = new DOMParser();
		xmlDoc = parser.parseFromString(xmlContent, 'text/xml');
	}
	catch(err)
	{
		alert(err);
		return
	}
	citations = xmlDoc.getElementsByTagName("citation");
	root = document.getElementById("main");
	thisHtml = "<html><title>Bibliography for "+topicName+"</title><body>\n";
	//alert("citations.len = "+citations.length);
	var tmpnode;
	for(c = 0; c < citations.length; c++)
	{
		//extract the values from the citation xml
		tmpnode = citations.item(c).getElementsByTagName("weblink").item(0).childNodes;
		if(tmpnode.length)
		{
			link = tmpnode.item(0).data;
			link = trimString(link);
		}
		else
		{
			link = "";
		}
		tmpnode = citations.item(c).getElementsByTagName("text").item(0).childNodes;
		if(tmpnode.length)
		{
			text = tmpnode.item(0).data;
			text = trimString(text);
			//alert("about to regex on "+text);
			regx = /\n\n/g ;
			tempStr = new String(text);
			text = tempStr.replace(regx, '<p>');
			//alert("done with regex: "+text);
		}
		else
		{
			text = "";
		}
		tmpnode = citations.item(c).getElementsByTagName("title").item(0).childNodes;
		if(tmpnode.length)
		{
			title = tmpnode.item(0).data;
			title = trimString(title);
		}
		else
		{
			title = "";
		}
		//alert("LINK: <"+link+">\nTEXT: <"+text+">\nTITLE: <"+title+">");
		fulldate = citations.item(c).getElementsByTagName("date").item(0);
		month = fulldate.getAttribute("month");
		day = fulldate.getAttribute("day");
	   	year = fulldate.getAttribute("year");
		hour = fulldate.getAttribute("hour");
		min = fulldate.getAttribute("min");
		sec = fulldate.getAttribute("sec");
		ampm = fulldate.getAttribute("ampm");
		//go through the format string and construct the html string
		for(d = 0; d < format.length; d++)
		{
			//these values are abitrary, can be changed.
			switch(format.charAt(d))
			{
				case '%': //check for format char
					if( d + 1 < format.length)
					{
						switch(format.charAt(d+1))
						{
							case 'T': thisHtml = thisHtml + title; break
							case 'Q': thisHtml = thisHtml + text; break
							case 'L': thisHtml = thisHtml + link; break
							case 'M': thisHtml = thisHtml + month; break
							case 'D': thisHtml = thisHtml + day; break
							case 'Y': thisHtml = thisHtml + year; break
							case 'H': thisHtml = thisHtml + hour; break
							case 'N': thisHtml = thisHtml + min; break
							case 'S': thisHtml = thisHtml + sec; break
							case 'A': thisHtml = thisHtml + ampm; break
							//if its not a defined value, print it raw
							default: thisHtml = thisHtml + format.charAt(d) + format.charAt(d+1);
						}
						d++;
					}
					else //it's a % at the end of the format str. so odd, add it
					{
						thisHtml = thisHtml + format.charAt(d);
					}
					break
				default: thisHtml = thisHtml + format.charAt(d);
			}
		}
		thisHtml = thisHtml + "\n<p>\n";
	}
	if(citations.length == 0)
	{
		thisHtml = thisHtml+"No Citations for this topic";
	}
	thisHtml = thisHtml+"</body></html>";
	//alert("saving to "+inFname+"generated.html");
	save(inFname+"generated.html", thisHtml);

	var aFile = Components.classes["@mozilla.org/file/local;1"]
        .createInstance(Components.interfaces.nsILocalFile);
	if (!aFile)
	{
		alert("in loadPage, aFile = null");
		return false;
	}
	// next, assign URLs to the file components
	aFile.initWithPath(inFname+"generated.html");
	var URL = Components.classes["@mozilla.org/network/protocol;1?name=file"]. 
		createInstance(Components.interfaces.nsIFileProtocolHandler). 
		getURLSpecFromFile(aFile);

	//alert("got URL = "+URL);

	gBrow = window.opener.gBrowser;
	newTab = gBrow.addTab(URL, null);
	gBrow.selectedTab = newTab;
}
